<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

function current_crypto_update(){
	$alldata = '';
	foreach(scandir(CURRENT_CRYPTO_DIR.'includes/currents/functions') as $myfile){
		
		if(is_file(CURRENT_CRYPTO_DIR.'includes/currents/functions/'.$myfile)){
			require_once(CURRENT_CRYPTO_DIR.'includes/currents/functions/'.$myfile);
			$func = 'get_'.str_replace('.php', '', $myfile);

			$data = $func();
			$alldata = $alldata.$myfile.'<br />';
			
			file_put_contents(CURRENT_CRYPTO_DIR.'includes/currents/'.$data['type'].'/'.$data['code'].'.json', json_encode($data));
		}
	}
	wp_schedule_single_event( current_time('timestamp') + get_option('current_interval')*1, 'current_crypto_update');
	return($alldata);
}

function current_crypto_create($attr){
	if($attr['in']){
		if(file_exists(CURRENT_CRYPTO_DIR.'includes/currents/in/'.$attr['in'].'.json')){
			$in = json_decode(file_get_contents(CURRENT_CRYPTO_DIR.'includes/currents/in/'.$attr['in'].'.json'), true);
			if($attr['to']){
				if(file_exists(CURRENT_CRYPTO_DIR.'includes/currents/to/'.$attr['to'].'.json')){
					$to = json_decode(file_get_contents(CURRENT_CRYPTO_DIR.'includes/currents/to/'.$attr['to'].'.json'), true);
					return('<p><b>1</b>'.$in['znak'].' = <b>'.(round($in['rest'] * $to['rest'], $attr['float'])).'</b>'.$to['znak'].'</p>');
				}
			}else{
				return('Укажите второй параметр');
			}
		}else{
			return('Ошибка: такого курса нет');
		}
			
	}else{
		return('Укажите первый параметр');
	
	}

	
}



add_shortcode('current_crypto', 'current_crypto_create');

function wpb_load_widget() {
    register_widget('wpb_widget');
}
add_action('widgets_init', 'wpb_load_widget');

class wpb_widget extends WP_Widget{

	function __construct(){
		parent::__construct(
			'wpb_widget', 
			__('Current Crypto', 'wpb_widget_domain'),
			array( 'description' => __( 'Виждет для вывода криптовалют', 'wpb_widget_domain' ), ) 
		);
	}
	 
	public function widget($args, $instance){
		$current_widget_float = apply_filters('float', $instance['float']);
		$current_widget_in = apply_filters('in', $instance['in']);
		$current_widget_to = apply_filters('to', $instance['to']);
	 
		if (!empty($current_widget_float) && !empty($current_widget_in) && !empty($current_widget_to)){
			$create_attr = array(
				'in' => $current_widget_in,
				'to' => $current_widget_to,
				'float' =>$current_widget_float
			);
			echo __(((current_crypto_create($create_attr))), 'wpb_widget_domain');
		}
	}

	public function form($instance){
		if(isset($instance['float'])){
			$current_float = $instance['float'];
		}else{
			$current_float = __('2', 'wpb_widget_domain');
		}
		if(isset($instance['in'])){
			$current_in = $instance['in'];
		}else{
			$current_in = __('btc', 'wpb_widget_domain');
		}
		if(isset($instance['to'])){
			$current_to = $instance['to'];
		}else{
			$current_to = __('usd', 'wpb_widget_domain');
		}

	?>
	<p>
		<label for="<?php echo $this->get_field_id('float'); ?>">Сколько показывать цифр после точки?</label><br />
		<input type="number" id="<?php echo $this->get_field_id('float'); ?>" name="<?php echo $this->get_field_name( 'float' ); ?>" min="0" max="10" value="<?php echo esc_attr($current_float); ?>" />
	</p>
	<p>
		<label for="<?php echo $this->get_field_id('in'); ?>">Выберите криптовалюту</label><br />
		<select id="<?php echo $this->get_field_id('in'); ?>" name="<?php echo $this->get_field_name('in'); ?>">
		<?php
		$current_in = esc_attr($current_in);
		foreach(scandir(CURRENT_CRYPTO_DIR.'includes/currents/in') as $myfile){
			if(is_file(CURRENT_CRYPTO_DIR.'includes/currents/in/'.$myfile)){
				$crypto_in = json_decode(file_get_contents(CURRENT_CRYPTO_DIR.'includes/currents/in/'.$myfile), true);?>
				<option <?php if($current_in == $crypto_in['code']){ echo 'selected="selected"';} ?> value="<?php echo $crypto_in['code']; ?>"><?php echo $crypto_in['text']; ?></option>
			<?php } }?>
		</select>
	</p>
	<p>
		<label for="<?php echo $this->get_field_id('to'); ?>">Выберите валюту</label><br />
		<select id="<?php echo $this->get_field_id('to'); ?>" name="<?php echo $this->get_field_name('to'); ?>">
		<?php
		$current_to = esc_attr($current_to);
		foreach(scandir(CURRENT_CRYPTO_DIR.'includes/currents/to') as $myfile){
			if(is_file(CURRENT_CRYPTO_DIR.'includes/currents/to/'.$myfile)){
				$crypto_in = json_decode(file_get_contents(CURRENT_CRYPTO_DIR.'includes/currents/to/'.$myfile), true);?>
				<option <?php if($current_to == $crypto_in['code']){ echo 'selected="selected"';} ?> value="<?php echo $crypto_in['code']; ?>"><?php echo $crypto_in['text']; ?></option>
			<?php } }?>
		</select>
	</p>
	<?php }
	public function update($new_instance, $old_instance){
		$instance = array();
		$instance['float'] = (!empty($new_instance['float'])) ? strip_tags($new_instance['float']) : '';
		$instance['in'] = (!empty($new_instance['in'])) ? strip_tags($new_instance['in']) : '';
		$instance['to'] = (!empty($new_instance['to'])) ? strip_tags($new_instance['to']) : '';
		return $instance;
	}
}